  //
  // handle the command-line arguments and print out some information before we start to loop.
  //
  cout << endl;

  if (argc>2 ) {
    cout << "\n" << CYellow << "  Usage: " << CNone << argv[0] << " [number of required tracks]" << endl << endl;
    return 1;
  }

  Long64_t n_requested_tracks = -1;
  if (argc==2) {
    n_requested_tracks = atoi(argv[1]); // will only respond to a sensible request
    if (n_requested_tracks<0) n_requested_tracks=0;
    if (n_requested_tracks>=0 && n_requested_tracks<n_available_tracks) n_tracks_to_loop_over=n_requested_tracks;
  }

  cout << CYellow << " INFO: " << CNone << "Input ntuple file: " << CBlue << input_ntuple_files << CNone << endl;
  cout << CYellow << " INFO: " << CNone << "Output histogram file: " << CBlue << output_histogram_file << CNone << endl;

  if (n_requested_tracks>=0)
    cout << CYellow << " INFO: " << CNone << "Number of request tracks: " << CBlue << n_requested_tracks << CNone << endl;

  cout << CYellow << " INFO: " << CNone << "Number of available tracks in the ntuple: " << CBlue << n_available_tracks << CNone << endl;

  int percent = 100*n_tracks_to_loop_over/n_available_tracks;
  cout << CYellow << " INFO: " << CNone << "We will loop over "
                               << CBlue << n_tracks_to_loop_over
                               << CNone << " tracks ("<< CBlue << percent << "%" << CNone << ")." << endl;
