#include "TRandom3.h"
TRandom3 *rng = new TRandom3();

void overlay_correction(

  unsigned int &word,  // the bit-pattern to corrected
  int det,             // bec region
  double occupancy,    // global, partition, track?
  bool isXenonStraw,   // is Xenon Straw
  bool isElectron)     // We are working only with signal event tracks

{

  if (word & 0x00020000u) return; // don't bother if the middle HT bit is already set.

  double m_HTOccupancyCorrectionEC        = 0.090;
  double m_HTOccupancyCorrectionB         = 0.110;
  double m_HTOccupancyCorrectionEC_noE    = 0.050;
  double m_HTOccupancyCorrectionB_noE     = 0.060;

  double m_HTOccupancyCorrectionEC_Ar        = 0.;
  double m_HTOccupancyCorrectionB_Ar         = 0.;
  double m_HTOccupancyCorrectionEC_Ar_noE    = 0.;
  double m_HTOccupancyCorrectionB_Ar_noE     = 0.;

  double HTOccupancyCorrection = 0.;

  if (isXenonStraw) { // Xenon
    if (isElectron) {
      HTOccupancyCorrection = abs(det) > 1 ? m_HTOccupancyCorrectionEC : m_HTOccupancyCorrectionB;
    } else {
      HTOccupancyCorrection = abs(det) > 1 ? m_HTOccupancyCorrectionEC_noE : m_HTOccupancyCorrectionB_noE;
    }
  } else {           // Argon
    if (isElectron) {
      HTOccupancyCorrection = abs(det) > 1 ? m_HTOccupancyCorrectionEC_Ar : m_HTOccupancyCorrectionB_Ar;
    } else {
      HTOccupancyCorrection = abs(det) > 1 ? m_HTOccupancyCorrectionEC_Ar_noE : m_HTOccupancyCorrectionB_Ar_noE;
    }
  }

  double rnd = rng->Uniform();
  if (occupancy * HTOccupancyCorrection > rnd) word = word | 0x00020000u;

}
