  // variables required
  double nPrecisionHits[6] = {0.0};
  double nTotalHits[6]     = {0.0};

  // Open the TFile before booking the histograms
  TFile *h_out = new TFile(output_histogram_file.c_str(),"recreate");

  TNamed n1("NTupleFile1",input_ntuple_file1.c_str());
  TNamed n2("NTupleFile2",input_ntuple_file2.c_str());
  n1.Write();
  n2.Write();

  // Book histograms
  TH1D        *hResidual[6][2][10][2];
  TH1D        *hPrecisionHits[6], *hTubeHits[6], *hOutlierHits[6];
  TEfficiency *eHTprob[4];
  TProfile    *pRT[6][2];

  string   spartition[6] = {"BA","BC","EAA","EAB","ECA","ECB"};
  string         sbec[4] = {"BA","BC","EA","EC"};
  string         sgas[2] = {"Xe","Ar"};
  string   title1, title2;

  for(int ip=0; ip<6; ip++){
  for(int ig=0; ig<2; ig++){
  for(int io=0; io<10;io++){
      title1 = "hRes_"+spartition[ip]+"_"+sgas[ig]+"_Occu_"+to_string(io)+"_sample"+to_string(1);
      title2 = ";Unbiased residual ("+spartition[ip]+" "+sgas[ig]+" occ_"+to_string(io)+" sample_"+to_string(1)+");Entries";
      hResidual[ip][ig][io][0] = new TH1D(title1.c_str(), title2.c_str(), 100,-1.,1.);

      title1 = "hRes_"+spartition[ip]+"_"+sgas[ig]+"_Occu_"+to_string(io)+"_sample"+to_string(2);
      title2 = ";Unbiased residual ("+spartition[ip]+" "+sgas[ig]+" occ_"+to_string(io)+" sample_"+to_string(2)+");Entries";
      hResidual[ip][ig][io][1] = new TH1D(title1.c_str(), title2.c_str(), 100,-1.,1.);
  }}}

  for(int id=0; id<4; id++){
      double min,max;
      int nbins;
      title1 = "eHTprob_"+sbec[id];
      title2 = ";Module Layer "+sbec[id]+";HT Probability";
      if(id<2) {nbins = 3; min=-0.5;  max=2.5;}
      else     {nbins = 14; min=-0.5; max=13.5;}
      eHTprob[id] = new TEfficiency(title1.c_str(), title2.c_str(), nbins,min,max);
  }

  for(int ip=0; ip<6; ip++){
  for(int ig=0; ig<2; ig++){
      title1 = "pRT_"+spartition[ip]+"_"+sgas[ig];
      title2 = ";Drift Time [ns] "+spartition[ip]+" "+sgas[ig]+";Track-to-Wire Distance [mm]";
      pRT[ip][ig] = new TProfile(title1.c_str(), title2.c_str(), 16, 0,50, 0,2.2);
  }}

  for(int ip=0; ip<6; ip++){
      title1 = "hPrecisionHits_"+spartition[ip];
      title2 = ";Number of Precision Hits Per Track "+spartition[ip]+";Entries";
      hPrecisionHits[ip] = new TH1D(title1.c_str(), title2.c_str(), 53,-1.5,51.5);
  }

  for(int ip=0; ip<6; ip++){
      title1 = "hTubeHits_"+spartition[ip];
      title2 = ";Number of Tube Hits Per Track "+spartition[ip]+";Entries";
      hTubeHits[ip] = new TH1D(title1.c_str(), title2.c_str(), 53,-1.5,51.5);
  }

  for(int ip=0; ip<6; ip++){
      title1 = "hOutlierHits_"+spartition[ip];
      title2 = ";Number of Outlier Hits Per Track "+spartition[ip]+";Entries";
      hOutlierHits[ip] = new TH1D(title1.c_str(), title2.c_str(), 53,-1.5,51.5);
  }
